{{!
    This file is part of Moodle - http://moodle.org/

    Moodle is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Moodle is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
}}
{{!
    @template mod_laejss/lti_report

    LTI report for teachers.

    Classes required for JS:
    * none

    Context variables required for this template:
    * none
}}
<!DOCTYPE HTML>
<html>
<head>

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <title>EjsS Monitor</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel='stylesheet'>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.css" rel="stylesheet">
    <link href='https://fonts.googleapis.com/css?family=Noto Sans' rel='stylesheet'>
	<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.12.1/datatables.min.css"/>
</head>

<style>
.loader {
    display: block;
    position: fixed;
    left: 50%;
    top: 50%;
    width: 40px;
    height: 40px;
    transform: translate(-50%, -50%);
}
.spinner {
    border: 4px solid rgba(255, 255, 255, 0.3); /* Color de fondo del spinner */
    border-top-color: #3498db; /* Color principal del spinner */
    border-radius: 50%;
    width: 100%;
    height: 100%;
    animation: spin 1s linear infinite;
}
@keyframes spin {
    to {
      transform: rotate(360deg);
    }
}
.slsheader, .slsheader:hover, .slsheader:active, .slsheader:visited, .slsheader:focus {
	--bs-table-bg: #ced3d9;
	background-color: #ced3d9;
}
.slstextstudents {
	color: #2b63d9;
	opacity: 0.75;
}
.slscorrect, .slscorrect:hover, .slscorrect:active, .slscorrect:visited, .slscorrect:focus {
	--bs-table-bg: rgb(103, 183, 23, 0.5);
	background-color: rgb(103, 183, 23, 0.5);
}
.slspartially, .slspartially:hover, .slspartially:active, .slspartially:visited, .slspartially:focus {
	--bs-table-bg: rgb(251, 188, 4, 0.5);
	background-color: rgb(251, 188, 4, 0.5);
}
.slswrong, .slswrong:hover, .slswrong:active, .slswrong:visited, .slswrong:focus {
	--bs-table-bg: rgb(193, 65, 73, 0.5);
	background-color: rgb(193, 65, 73, 0.5);
}
.slsonline, .slsonline:hover, .slsonline:active, .slsonline:visited, .slsonline:focus {
	background-color: #2b63d9;
	opacity: 0.75;
}
.slscomplete, .slscomplete:hover, .slscomplete:active, .slscomplete:visited, .slscomplete:focus {
	background-color: #2b63d9;
	opacity: 0.75;
}
.slsincomplete, .slsincomplete:hover, .slsincomplete:active, .slsincomplete:visited, .slsincomplete:focus {
	background-color: #fbbc04;
}
.slsoverdue, .slsoverdue:hover, .slsoverdue:active, .slsoverdue:visited, .slsoverdue:focus {
	background-color: rgb(193, 65, 73, 0.75);
}
.slstextcomplete {
	color: #2b63d9;
}
.slstextincomplete {
	color: #fbbc04;
}
.slstextoverdue {
	color: rgb(193, 65, 73, 0.75);
}

table.dataTable thead>tr>th.sorting:before, table.dataTable thead>tr>th.sorting:after,
table.dataTable thead>tr>th.sorting_asc:before, table.dataTable thead>tr>th.sorting_asc:after, 
table.dataTable thead>tr>th.sorting_desc:before, table.dataTable thead>tr>th.sorting_desc:after, 
table.dataTable thead>tr>th.sorting_asc_disabled:before, table.dataTable thead>tr>th.sorting_asc_disabled:after, 
table.dataTable thead>tr>th.sorting_desc_disabled:before, table.dataTable thead>tr>th.sorting_desc_disabled:after, 
table.dataTable thead>tr>td.sorting:before, table.dataTable thead>tr>td.sorting:after, 
table.dataTable thead>tr>td.sorting_asc:before, table.dataTable thead>tr>td.sorting_asc:after, 
table.dataTable thead>tr>td.sorting_desc:before, table.dataTable thead>tr>td.sorting_desc:after, 
table.dataTable thead>tr>td.sorting_asc_disabled:before, table.dataTable thead>tr>td.sorting_asc_disabled:after, 
table.dataTable thead>tr>td.sorting_desc_disabled:before, table.dataTable thead>tr>td.sorting_desc_disabled:after
{
    font-size: 1.5em;
}

</style>

<body style="font-family: 'Noto Sans';">

<div id="loader" class="loader">
  <div class="spinner"></div>
</div>

<div id="allcontent" style="display: none; background-color: #e7e9ec; min-height: -webkit-fill-available;">
    <div class="col-10 d-table mx-auto p-0" style="background-color: #f3f5f8;">
	    <div class="header m-4">
		    <div class="header-wrapper">
		     	<h3 class="title" style="font-size: 24px; font-weight: bold;">
			    	<span>EJSS Teacher's Dashboard</span>
		    	</h3>
		    	<h4 class="subtitle" style="font-size: 16px;"> 
	    		    <span>{{{title}}}</span> 
	    		</h4>
	    	</div>
	    </div>
	    <div class="content" style="background-color: #fff;">
		    <div class="p-4">
				{{#overview}}
				<div class="header border-0" style="width: 300px;">
					<div class="container">
						<div class="header d-inline-flex border-0">
							<div class="mx-2 text-center title">
								<div class="value fw-bold h2 slstextcomplete">{{complete}}</div>
								<div class="label fw-bold text-secondary"><small>COMPLETE</small></div>
							</div>
							<div class="border border-2 border-end-0"></div>
							<div class="mx-2 text-center">
								<div class="value fw-bold h2 slstextincomplete">{{incomplete}}</div>
								<div class="label fw-bold text-secondary"><small>INCOMPLETE</small></div>
							</div>
							<div class="border border-2 border-end-0"></div>
							<div class="mx-2 text-center">
								<div class="value fw-bold h2 slstextoverdue">{{overdue}}</div>
								<div class="label fw-bold text-secondary"><small>OVERDUE</small></div>
							</div>
						</div>		
						<div class="progress mx-2" style="height: 5px;">
						  <div class="progress-bar slscomplete" role="progressbar" style="width: {{completepct}}%"></div>
						  <div class="progress-bar slsincomplete" role="progressbar" style="width: {{incompletepct}}%"></div>
						  <div class="progress-bar slsoverdue" role="progressbar" style="width: {{overduepct}}%"></div>
						</div>
					</div>
				</div>
				{{/overview}}
                <table id="atable" class="table table-striped table-bordered border">
                    <thead style="background-color: #546579;">
						<tr style="background-color: #fff;">
							<th id="legendrow" colspan="100%">
								<div class="float-start form-check form-switch">
								  <input class="form-check-input" type="checkbox" id="extendTableChecked" checked>
								  <label class="form-check-label" for="extendTableChecked">Extended table</label>
								</div>
								<div class="float-end">
								<button type="button" class="btn" onClick="history.back();">
									<i class="bi bi-arrow-left"></i>
								</button>
								<div class="float-end">
								<button id="refreshBtn" type="button" class="btn">
									<i class="bi bi-arrow-repeat"></i>
								</button>
								<button id="downloadCsv" class="btn" type="button">
								    <i class="bi bi-download"></i>
								</button>
								<div class="form-check form-switch d-inline-block">
								  <input class="form-check-input" type="checkbox" id="showMarkChecked" checked>
								  <label class="form-check-label" for="showMarkChecked">Show mark</label>
								</div>
								<button type="button" class="btn" data-bs-toggle="modal" data-bs-target="#legendModal">
									<i class="bi bi-map text-secondary"></i>
								</button>
								</div>
							</th>
						</tr>
                        <tr>
                            <th id="student" colspan="1">
                                <div class="label m-2 text-light text-center"> Students </div>
                            </th>
                            <th id="status" class="slsheader" colspan="1">
                                <div class="label m-2 text-center"> Online Status </div>
                            </th>
                            <th id="ass1" class="slsheader" colspan="1">
                                <div class="label m-2 text-center"> Activity Status 
								</div>
                            </th>
							{{#header}}
                            <th class="acol slsheader" colspan="1">
                                <div class="label m-2 text-center"> {{name}} 
									<button type="button" class="btn p-0" data-bs-toggle="tooltip" data-bs-placement="top" data-bs-html="true" title="{{description}}">
										<i class="bi bi-info-circle"></i>
									</button>
									<div class="label fw-normal"> [{{maxrank}}] </div>
									<div class="progress mt-1" style="height: 15px; border-radius: 0px; border-style: solid; border-width: 1px;" 
										data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-html="true" 
											title="<div class='label slswrong'>{{wrongpct}}%</div>">
									  <div class="progress-bar slswrong" role="progressbar" style="width: {{wrongpct}}%"></div>
									  <div class="progress-bar slspartially" role="progressbar" style="width: {{partialpct}}%"></div>
									  <div class="progress-bar slscorrect" role="progressbar" style="width: {{correctpct}}%"></div>
									  <div class="progress-bar bg-light" role="progressbar" style="width: {{notpct}}%"></div>
									</div>
								</div>
                            </th>
                            <th class="slsheader" style="display: none;" colspan="1">
                                <div class="label m-2 text-center"> {{name}} Hint
								</div>
                            </th>
							{{/header}}
                            <th id="final" class="slsheader" colspan="1">
                                <div class="label m-2 text-center"> Final Mark 
								</div>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
						{{#users}}
                        <tr>
                            <th scope="row" colspan="1">
                                <div class="value slstextstudents">{{name}}</div>
                            </th>
                            <td colspan="1">
                                <div class="value text-center">
                                    <button class="btn {{online}}" style="font-weight: bold;">
                                        {{views}}
                                    </button>
                                </div>
                            </td>
							{{#assessment}}
                            <td colspan="1">
                                <div class="value text-center">
                                    <button class="btn {{color}}" style="font-weight: bold;">
                                        {{text}}
                                    </button>
                                </div>
                            </td>
							{{/assessment}}
							{{#taskstatus}}
                            <td class="acol text-center align-middle {{status}}" colspan="1">
								<div class="label m-0 text-light"> 
									<button type="button" class="btn p-0" data-bs-toggle="tooltip" data-bs-placement="top" 
											data-bs-html="true" title="{{{history}}}">
										{{#notsubmmited}}
										<button class="btn btn-white border-primary"></button>
										{{/notsubmmited}}
										{{^notsubmmited}}
										<span class="marks" style="display: none;">{{{mark}}}</span>
										<i class="bi bi-eye-slash eye" style="display: none;"></i>
										{{/notsubmmited}}
									</button>
								</div>
                            </td>
                            <td class="text-center align-middle {{status}}" style="display: none;" colspan="1">
                                        {{{history}}}
								</div>
                            </td>
							{{/taskstatus}}
							{{#assessment}}
                            <td class="text-center align-middle" colspan="1" data-order="{{marksum}}">
								<div class="label fw-normal marks" style="display: none;"> {{marksum}}/{{markmax}} </div>
								<i class="bi bi-eye-slash eye" style="display: none;"></i>
                            </td>
							{{/assessment}}
                        </tr>
						{{/users}}
                    </tbody>
                </table>
		    </div>
	    </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="legendModal" tabindex="-1" aria-labelledby="legendModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header p-2">
        <h5 class="modal-title" id="legendModalLabel">Legend</h5>
		<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
		<div class="p-2">
        <button class="btn slsonline" style="font-weight: bold;">N</button><span class="mx-4">Online student with N views</span>
        </div>
		<div class="p-2"> 
		<button class="btn btn-secondary" style="font-weight: bold;">N</button><span class="mx-4">Offline student with N views</span>
        </div>
		<div class="p-2">
        <button class="btn btn-white border-primary"></button><span class="mx-4">Not Submitted</span>
        </div>
		<div class="p-2">
        <button class="btn slscorrect"></button><span class="mx-4">Correct</span>
        </div>
		<div class="p-2">
        <button class="btn slspartially"></button><span class="mx-4">Partially Correct</span>
        </div>
		<div class="p-2">
        <button class="btn slswrong"></button><span class="mx-4">Wrong</span>
        </div>
      </div>
    </div>
  </div>
</div>

<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.2/dist/umd/popper.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.12.1/js/dataTables.bootstrap5.min.js"></script>
<script src="https://cdn.datatables.net/buttons/2.2.3/js/dataTables.buttons.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
<script src="https://cdn.datatables.net/buttons/2.2.3/js/buttons.html5.min.js"></script>
<script> 

$( document ).ready(function() {
	// tooltips
	var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
	var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
	  return new bootstrap.Tooltip(tooltipTriggerEl)
	})

	// show mark
	var showMarkTable = sessionStorage.getItem("showMarkTable");
	if (showMarkTable == "false") {
		$('#showMarkChecked').prop('checked', false);
		$('.eye').show();
	} else {
		$('.marks').show();	
	}
	$('#showMarkChecked').on("click",function(event){ 
		if ($(this).prop('checked')) {
			$('.eye').hide();
			$('.marks').show();
		} else {
			$('.marks').hide();
			$('.eye').show();
		}
	});
	
	// refresh button
	$('#refreshBtn').on("click",function(event){
		sessionStorage.setItem('showMarkTable', $('#showMarkChecked').prop('checked')); 
		sessionStorage.setItem('extendedTable', $('#extendTableChecked').prop('checked')); 
		window.location.reload();
	});

	// download button
	$('#downloadCsv').on("click",function(event){
        table.button('.buttons-excel').trigger();
	});

	// table
	var table = $('#atable').DataTable( { paging: false, searching: false, ordering: true,
        buttons: [{
            extend: 'excelHtml5',
            title: '',
            exportOptions: {
                format: {
                    header: function(data, columnIdx) {
                        // remove HTML tags
                        var noQuotes = data.replace(/"[^"]*"/g, ''); 
                        var noHtml = noQuotes.replace(/<[^>]+>/g, ''); 
                        return noHtml.replace(/\[[^\]]*\]/g, '').trim();
                    }, 
                    body: function(data, row, column, node) {
                        // remove HTML tags
                        // replaceBr = data.replace(/<br\s*\/?>/gi, ', ');
                        var noQuotes = data.replace(/"[^"]*"/g, '');
                        return noQuotes.replace(/<[^>]+>/g, '').trim();
                    }
                }
            }
        }
            ] } );
	$('#legendrow').attr('colspan', '100%');
	
	// extended table
	var extendedTable = sessionStorage.getItem("extendedTable");
	if (extendedTable == "false") {
		$('#extendTableChecked').prop('checked', false);
		$('.acol').hide();
	}
	$('#extendTableChecked').on("click",function(event){ 
		if ($(this).prop('checked')) {
			$('.acol').fadeIn();
		} else {
			$('.acol').fadeOut();
		}
	});
    
    // show content
    $('#loader').hide();
    $('#allcontent').show();
});
</script>

</body>
</html>
